APP BUILD: 2015.04.30.11.02.33
__BAS_RELEASE=1.2.11
BASgateway-LX Application Revision History

1.0.0		02-03-2012	MW

1.0.1		05-10-2012	MW
				Fix a bug in Modbus Configuration webpage: 
				The page freezes when input a non-zero Modbus TCP address

1.0.2		06-28-2012	MW
				Modify the source address for modbus devices from 1 byte (MAC address)
				to 6 bytes (IP address, 0 and MAC address).
				in BACnet.
		
1.0.3		07-23-2012	MW
				Modify COV code in BACnet IP application. The total number of COV is 200
				(100 analog and 100 binary) no matter which modbus device subscribes.
		
1.1.0		08-06-2012	HP
				Add authentication and firmware upload in webpage.
				MW
				Fix bugs in COV code in BACnet IP application: when the number of 
				COV is more than 10, BACnet-IP code runs of memory.

1.1.1		08-16-2012	MW
				Fix bugs in BACnet-IP COV: 
				1). when more than one Modbus devices subscribes COV,
				BACnet-IP code crashes.				
				2). Accept more Analog COV subscriptions than maximum limit (100)
				Fix a bug in webpage: when baudrate 115200 is selected, the Configure
				Settings screen has an error.

1.1.2		08-23-2012	MW
				Fix a bug in data-server:
				When multiple devices are mapped, the data-server crashes in polling lots of 
				objects in different devices. This is caused by the overflowed index number
				in object index search function. 

1.1.3		08-27-2012	MW
				Fix a bug in Mapping Status applet: after you select different item in device instance, 
				the applet got an error.
				Delete group_enable_flag to enable grouping in data-server based on CSV file.

1.1.4		09-14-2012	MW
				Fix a bug in data-server:
				When we are polling mapped Modbus devices and routing Modbus/TCP to Modbus/RTU at the same time, 
				we get errors on polling device (offline) and/or routing device.
				In Bacnet-ip code, add support to wild card device instance 0x3FFFFF
				Change the deafault value of Bacnet Virtual Network from 1001 into 1100
				Change the maximum value of Consecutive RD Delay from 100ms into 1000ms
				Change the maximum value of Max Consecutive RD from 32 into 100
				In "startup", change the delay time between data-server and bacnet-ip from 5s into 10s
				Fix two bugs in Bacnet-ip code:
				1). We don't respond to Who-Is with device instance number
				2). Response to Protocol-object-types-supported in device object was not right

1.1.5		09-19-2012 	MW
				Fix a bug in Mapping Configuration webpage: the webpage doesn't give an error when we 
				generate mapped file with duplicate Modbus address.
				Display the number of mapped devices and objects in Mapping Configuration page.
				Increase Max Consecutive RD from 100 into 125
										
1.1.6		09-25-2012 	MW
 				Fix a bug in bacnet-ip code: when only one object in a Modbus device is mapped,
 				if the code receives a BACnet request with another object instance,
 				it will not respond to any request.

1.1.7		10-26-2012	MW
  				Change bacnet-ip code: if BASgatewayLX receives a request without routing
  				information on device properties in mapped Modbus devices, we reply with an error
  				message. In the previous versions, we reply with an ACK.
                               	Fix a bug in bacnet-ip code: when receiving a BACnet request with only Source network
                             	or both source and destination network in NPDU, the reponse is wrong
				Increase the MAX number of template files in /data/template from 32 to 100
 
1.1.8		11-07-2012	MW
  				Fix a bug in BACnet COV notification: after we subscribe COV to one output object from one PC
				and get an ACK, we change the resent value of that object from another PC, the COV
				notification will be sent to the new PC not the subscribed PC.

1.1.9		12-04-2012	MW
  				Fix a bug in System Configuration applet.

1.1.10		12-06-2012	MW
  				Fix a bug in System ConfigurationModbus Utility applet: it can't read 3X registers.

1.2.0		02-20-2013	MW
				Change default device name and device instance in bac_cfg.xml
				In AddPanel.java, device name will be Modbus Unit + device instance if user doesn't change it 
				
		04-01-2013	MW
				Add support to BACnet Integer Value and Positive Integer Value objects.
				Add new features in Modbus Utility on the webpage:
				a). Add support of Modbus/TCP devices
				b). Read/Write unmapped registers in mapped devices.
				Add support of all engineering units in BACnet standard 2010

		05-20-2013	MW
				Add "Device Profile" button in Mapping Configuration page so that user can delete 
				device profile.
				Add Max Consecutive RD configuration in Add, Copy and Modify Device pages
				Delete Max Consecutive RD in Configure Settings page. User can specify Max Consecutive read
				registers when grouping is enabled in each deice.
				Add COV for Integer Value and Positive Integer Value objects.
		
		06-13-2013	MW
				If parse_csv_file() != 0, add error statement in logread and ignore the file.
				Add PRESENT_VALUE_RAW, HI_LIMIT_RAW and LOW_LIMIT_RAW in data client functions to 
				handle integer and positive integer value
				Change the text display in MappingCfgApplet

		07-01-2013	MW
				Fix Java applet problem with Java 7u25:
				Can't Add, Copy or Modify profile in Mapping Configuration page.
				
1.2.1		07-21-2013 MW
				Fix bug in reading/writing registers of Bit32 format with Mapping Status.
				Fix bugs in Modbus Utility:
					Reading/Writing registers of Bit16 or Bit32 format get wrong value
					Reading/Writing non-existing registers still shows SUCCESS
					
		08-06-2013 MW	Fix bug in losing the first character of the register description in Add Device, 
				Copy Device and Modify Device page.

1.2.2		08-15-2013 MW	Fix a bug in BACNET-IP code: if two modbus devices with same mapped objects connected to one 
				basGatewayLX, only one can send COV notification. 

1.2.3		09-12-2013 MW	Correct misspelling engineering units: DEGREES_CELSIUS, DEGREE_DAYS_CELSIUS

1.2.4		10-17-2013 MW	Fix several bugs:
				1. Reboot button on Configure Setting page doesn't work sometimes.
				2. No scroll bar in Device Profile webpage.
				3. Consecutive Read is not set right in the polling list (data-server).
				4. The first chracter of BACnet object description in Modify Device page was missing
				5. Duplicate object name checking (data server): it checked duplicate object name throughout all devices.
					According to standard, object name should be unique throughout one device.

1.2.5		12-14-2013 MW	Fix bugs in BACnet stack:
			   	1. Change unconfirmed COV notification in unicast
				2. Fix reversed port number in sctive_cov_subscription property
				3. Respond to unicast Who-Is with unicast I-Am.
				4. Fix status_flag in COV messages.
				5. Can't write Present Value property.
				Change Webpages:
				1. Display MAC Address on Home page
				2. Change Help section on Configure Settings page and Mapping Configuration page
				Use signed java applets

1.2.6		09-11-2014 MW	Fix bugs in BACnet stack:
				Doesn't respond to direct Who-Is with our network number: network number was reversed.
				
1.2.8		10-24-2014 MW	Fix bugs in data server:
				Can't write to present value of postive integer.
				MAX Objects in device profiles: 2000; MAX mapped objects: 1000.
				
1.2.9		06-02-2015 MW	Fix bugs in Java applets: Java applet doesn't work with Java 8. Change permission from
				"sandbox" into "all-permissions".
				Fix several issues in BACnet:
				1. Priority Array property in Positive Integer object has wrong data type (signed).
				2. Modbus device doesn't respond to ReadPropertyMultiple that read required/optional properties.
				3. Modbus device doesn't delete expired COV subscription in Active COV subscription
				4. Add unconfirmedCOVNotification in Protocol Support in device object
				5. In Postive Integer and Integer objects, present value in COV notification message is wrong. 
				6. Write a new value but don't see COV notification
				
1.2.10		03-25-2015 MW	Fix a bug in Bacnet-IP code:
				If several Modbus devices subscribe to COV, read active_cov_subscription on one device
				can crash bacnet-ip code.
		
1.2.11		03-25-2015 MW	Fix a bug in Bacnet-IP code:
				Model name is not right.

----------------RELEASE KEYWORD: KEEP AT END OF FILE

		This must be updated per the latest release number. It will be added 
		to the build.app file generated by the apps_make.sh script. The build.app
		file will be used by the applications to display the proper release number.
		
		NOTE:NO SPACES ALLOWED AROUND '='.
		
__BAS_RELEASE=1.2.11

